All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.actionprovider.support.olapgraphics
Class HttpOLAPGraphSupport

    com.sas.actionprovider.support.olapgraphics.HttpOLAPGraphSupport

All Implemented Interfaces:
  OLAPGraphAreaInterface

    @SASScope(value="ALL")
    public class HttpOLAPGraphSupport

In the context of the ActionProvider framework, this Support class assists in the registering and retrieval of actions for OLAP transformation bean viewer components.

Field Summary
`static java.lang.String` | `ANALYSIS_LABEL_ACTION` The actionType key used to define the anaylsis label actions.
`static java.lang.String` | `CATEGORIZATION_LABEL_ACTION` The actionType key used to define the categorization label actions.
`static java.lang.String` | `CATEGORIZATION_VALUE_ACTION` The actionType key used to define the categorization value action.
`static java.lang.String` | `RESIZE_GRAPH_ACTION` The actionType key used to define the graph resize actions.

Fields inherited from class com.sas.actionprovider.support.olapgraphics.BaseOLAPGraphSupport
`ASCENDING_SORT_ACTION, COLLAPSE_ACTION, DESCENDING_SORT_ACTION, DRILL_DOWN_ACTION, DRILL_UP_ACTION, EXPAND_ACTION`

Fields inherited from class com.sas.actionprovider.support.BaseActionProviderSupport
`AREA_DISABLED, AREA_VALUE_ATTRKEY, DISABLED, ENABLED, IS_CURRENT_STATE_DISABLED, MODEL_MEMBER_DISABLED, MODEL_STATE_DISABLED, MODEL_TYPE_DISABLED, NON_SPECIFIC_AREA, UNSUPPORTED, VIEWER_DISABLED`

Fields inherited from interface com.sas.actionprovider.support.olapgraphics.OLAPGraphAreaInterface
`ANALYSIS_LABEL_AREA, CATEGORIZATION_LABEL_AREA, CATEGORIZATION_VALUE_AREA, DATA_VALUE_AREA`

Constructor Summary
`HttpOLAPGraphSupport(java.lang.Class actionClass)` Constructor

Method Summary
`protected void` | `createDefaultActions()` Initializes the actionClass property and creates the default actions that this class supports.
`protected BaseAction` | `defineActionAttributes(BaseAction action, java.lang.String actionType, java.lang.String areaType)` Returns an action whose default dynamic attributes have been defined according to their actionType.
`protected java.util.Map` | `getActionScopeAttributeMap(java.lang.String actionType, ActionSupportFilter filter)` Returns mappings for a pre-defined set of Action attribute keys to their corresponding dynamic values for a specific area and a specific actionType.
`protected int` | `getActionStatus(BaseAction action, ActionSupportFilter filter)` Returns a status value indicating whether the Action is enabled for a specific area as described by various filter attributes.
`protected java.util.Map` | `getAreaScopeAttributeMap(ActionSupportFilter filter)` Returns mappings for a pre-defined set of Action attribute keys to their corresponding dynamic values for a specific area.
`protected java.lang.Object` | `getCustomAttributeValue(java.lang.String attributeName, ActionSupportFilter filter)` Returns a value for a specific custom attribute.
`protected java.util.Map` | `initializeShortActionTypeMap()` This method is called by the constructor and used to initiallize the `actionTypeToShortActionTypeMap` map.
`protected boolean` | `isConverted()`
`BaseAction` | `newActionInstance(java.lang.String actionType)` Return a newly instantiated default Action based on the specified actionType or return null if actionType not recognized.
`BaseAction` | `newActionInstance(java.lang.String areaType, java.lang.String actionType)` Return a newly instantiated default Action based on the specified actionType or return null if actionType not recognized.
`protected BaseAction` | `setActionAttributes(BaseAction action, ActionSupportFilter actionFilter)` Sets the action's attributes properly according to its actionType and the information supplied by the viewer component on the actionFilter.
`protected boolean` | `validArea(Area area, ActionSupportFilter filter)` Validates that the given Area's 'type' and, if specified, its 'value' constraints are met by the information provided on the action filter.

Methods inherited from class com.sas.actionprovider.support.olapgraphics.BaseOLAPGraphSupport
`initialize`

Methods inherited from class com.sas.actionprovider.support.BaseActionProviderSupport
`addDefaultAction, getAction, getActionId, getActionOrderList, getActionProvider, getActions, getActionScopeAttribute, getDefaultAction, getLocale, listActionTypes, listAreaTypes, listDefaultActions, reset, setAction, setActionOrderList, setActionProvider, setLocale`

Field Detail

### CATEGORIZATION_VALUE_ACTION

    public static final java.lang.String CATEGORIZATION_VALUE_ACTION

  The actionType key used to define the categorization value action.

  See Also:
    Constant Field Values

### CATEGORIZATION_LABEL_ACTION

    public static final java.lang.String CATEGORIZATION_LABEL_ACTION

  The actionType key used to define the categorization label actions.

  See Also:
    Constant Field Values

### ANALYSIS_LABEL_ACTION

    public static final java.lang.String ANALYSIS_LABEL_ACTION

  The actionType key used to define the anaylsis label actions.

  See Also:
    Constant Field Values

### RESIZE_GRAPH_ACTION

    public static final java.lang.String RESIZE_GRAPH_ACTION

  The actionType key used to define the graph resize actions.

  See Also:
    Constant Field Values

Constructor Detail

### HttpOLAPGraphSupport

    public HttpOLAPGraphSupport(java.lang.Class actionClass)

  Constructor

  Parameters:
    `actionClass` - The class used to instantiate new actions.

Method Detail

### defineActionAttributes

    protected BaseAction defineActionAttributes(BaseAction action,
                                                java.lang.String actionType,
                                                java.lang.String areaType)

  Returns an action whose default dynamic attributes have been defined according to their actionType. The method also sets each attributes meta attributes ( e.g. visible ) accordingly.

  Parameters:
    `action` - The action object whose properties are to be defined.
    `actionType` - the key associated with a defined action type.
  Returns:
    an action with all of its default attributes defined.

### newActionInstance

    public BaseAction newActionInstance(java.lang.String actionType)

  Return a newly instantiated default Action based on the specified actionType or return null if actionType not recognized.

  Parameters:
    `actionType` - the key associated with a defined action type.
  Returns:
    a new action of the specified type or null if the type is not recognized.

### newActionInstance

    public BaseAction newActionInstance(java.lang.String areaType,
                                        java.lang.String actionType)

  Return a newly instantiated default Action based on the specified actionType or return null if actionType not recognized.

  Specified by:
    `newActionInstance` in class `BaseActionProviderSupport`
  Parameters:
    `areaType` -
    `actionType` - the key associated with a defined action type.
  Returns:
    a new action of the specified type.

### createDefaultActions

    protected void createDefaultActions()

  Initializes the actionClass property and creates the default actions that this class supports. This method is called by the action provider that instantiates this support class.

  Overrides:
    `createDefaultActions` in class `BaseOLAPGraphSupport`

### getAreaScopeAttributeMap

    protected java.util.Map getAreaScopeAttributeMap(ActionSupportFilter filter)

  Description copied from class: `BaseActionProviderSupport`
  Returns mappings for a pre-defined set of Action attribute keys to their corresponding dynamic values for a specific area.

  Specified by:
    `getAreaScopeAttributeMap` in class `BaseActionProviderSupport`
  Parameters:
    `filter` - Defines the specific area.
  Returns:
    mappings for a pre-defined set of Action Attribues keys

### getActionScopeAttributeMap

    protected java.util.Map getActionScopeAttributeMap(java.lang.String actionType,
                                                       ActionSupportFilter filter)

  Description copied from class: `BaseActionProviderSupport`
  Returns mappings for a pre-defined set of Action attribute keys to their corresponding dynamic values for a specific area and a specific actionType.

  Overrides:
    `getActionScopeAttributeMap` in class `BaseActionProviderSupport`
    `filter` - Defines the specific area.

### getActionStatus

    protected int getActionStatus(BaseAction action,
                                  ActionSupportFilter filter)

  Description copied from class: `BaseActionProviderSupport`
  Returns a status value indicating whether the Action is enabled for a specific area as described by various filter attributes.

  If enabled, the value is: ``BaseActionProviderSupport.ENABLED``

  If disabled, the value may be one of the following values which indicate why the Action is disabled.

  - ``BaseActionProviderSupport.VIEWER_DISABLED``
  - ``BaseActionProviderSupport.AREA_DISABLED``
  - ``BaseActionProviderSupport.MODEL_TYPE_DISABLED``
  - ``BaseActionProviderSupport.MODEL_STATE_DISABLED``
  - ``BaseActionProviderSupport.MODEL_MEMBER_DISABLED``
  - ``BaseActionProviderSupport.IS_CURRENT_STATE_DISABLED``
  - ``BaseActionProviderSupport.DISABLED``
  - ``BaseActionProviderSupport.UNSUPPORTED``

  The status of an Action with a CommandSupportedInterface command whose `isSupported()` method returns false will have the `BaseActionProviderSupport.UNSUPPORTED` status bit set.

  The status of an Action with a CommandStatusInterface command will have the status bit value returned by the command's `getCommandStatus()` method.

  The Action's status may also be set with bit values that are determined by the support class in addition to a command.

  Overrides:
    `getActionStatus` in class `BaseActionProviderSupport`
  Parameters:
    `action` - The action for which status is to be determined.
    `filter` - The ActionSupportFilter that encapsulates all information describing the specific area.
  Returns:
    the boolean indicating whether the Action is enabled
  See Also:
    `CommandSupportedInterface`, `CommandStatusInterface`

### isConverted

    protected boolean isConverted()

### setActionAttributes

    protected BaseAction setActionAttributes(BaseAction action,
                                             ActionSupportFilter actionFilter)

  Sets the action's attributes properly according to its actionType and the information supplied by the viewer component on the actionFilter. The method is called for any action(s) returned by the getOverrideAction() and getCustomActions() method. It should also be called by the implementation of getActions() for every default action that needs to be returned. For the default drill, expand and collapse actions, the method sets the model, AXIS_INDEX, TUPLE_INDEX and the TUPLE_ELEMENT_INDEX action attributes. It requires the model and a tupleElement attribute on the actionFilter to set these attributes.

  Parameters:
    `action` - The action object whose attributes are to be set.
    `actionFilter` - the ActionSupportFilter that the component passed as an argument on the getActions() method.
  Returns:
    the action whose attributes have been set.

### validArea

    protected boolean validArea(Area area,
                                ActionSupportFilter filter)

  Validates that the given Area's 'type' and, if specified, its 'value' constraints are met by the information provided on the action filter. If the Area is null or its 'type' is null then boolean true is returned because then there are no constraints specified and, therefore, any specification of the current area on the actionFilter must be valid. Otherwise, the method validates that the area 'type' and, if specified, area 'value' match the current area state represented by information on the actionFilter. In the COLUMN_HEADER_AREA and the ROW_HEADER_AREA, the Area 'values' should be the name of a row or column header that matches the header of the tupleElement on the action filter.

  Specified by:
    `validArea` in class `BaseActionProviderSupport`
  Parameters:
    `area` - The Area object that may or may not specify certain area 'values'.
    `actionFilter` - the ActionSupportFilter that the component passed as an argument on the getActions() method.
  Returns:
    a boolean indicating whether the current area represented on the actionFilter matches any of the specified values on the Area object.
  See Also:
    `BaseActionProviderSupport.setAction(com.sas.actionprovider.BaseAction, java.util.Collection, com.sas.actionprovider.Area)`, `BaseActionProviderSupport.getActions(com.sas.actionprovider.ActionSupportFilter)`

### initializeShortActionTypeMap

    protected java.util.Map initializeShortActionTypeMap()

  This method is called by the constructor and used to initiallize the `actionTypeToShortActionTypeMap` map. This map should contain the ActionType as the key and the new short name as the value. The short names are used to generate ids for HttpActions.

  Overrides:
    `initializeShortActionTypeMap` in class `BaseActionProviderSupport`

### getCustomAttributeValue

    protected java.lang.Object getCustomAttributeValue(java.lang.String attributeName,
                                                       ActionSupportFilter filter)

  Description copied from class: `BaseActionProviderSupport`
  Returns a value for a specific custom attribute.

  If a support class can derive custom attribute values, then it should override this method.

  Otherwise, this method returns null.

  Overrides:
    `getCustomAttributeValue` in class `BaseActionProviderSupport`
  Parameters:
    `attributeName` - The name of the custom attribute
    `filter` - The object that encapsulates all the specific query information.
  Returns:
    a value for a specific custom attribute.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.